TunePtr = $C0
PatternPtr = $C2
ChannelNo = $C4
VoiceIndex = $C5
Pitch8Hold = $C6
SquareFlag = $C9
EnvOffset = $CC
MusicEnable = $CF


;	.export _main
	org $3000
_main:
	LDA #$50
	STA $D208
	LDA #$03
	STA $D20F
	JSR loc_0_1F06
	LDA #6
	LDY #<VBH
	LDX #>VBH
	JSR $E45C
@1:	jmp @1

VBH:
	PHA
	TXA
	PHA
	TYA
	PHA
	JSR UpdateMusic
	PLA
	TAY
	PLA
	TAX
	PLA
	JMP $E45F

loc_0_1F00:				
		JMP	MusicOn
; ---------------------------------------------------------------------------

loc_0_1F03:				
		JMP	MusicOff
; ---------------------------------------------------------------------------

loc_0_1F06:				
		DEC	SawTooth
		BPL	UpdateMusic
		LDA	#$A
		STA	SawTooth
		RTS	
; ---------------------------------------------------------------------------

UpdateMusic:				
		BIT	MusicControl
		BMI	SoundOff
		BVC	UpdateTune
		LDA	#0
		LDX	#$B

TuneInitLoop:				
		STA	ChannelIdx,X
		DEX	
		BPL	TuneInitLoop
		STA	MusicControl
		JMP	UpdateTune
; ---------------------------------------------------------------------------

SoundOff:				
		BVC	MusicDone
		LDA	#0
		LDX	#7

SoundOffLoop:				
		STA	$D200,X
		DEX	
		BPL	SoundOffLoop
		LDA	#$80
		STA	MusicControl

MusicDone:				
		RTS	
; ---------------------------------------------------------------------------

UpdateTune:				
		INC	SquareWave
		LDX	#2

NextChannel:				
		STX	ChannelNo
		INX	
		TXA	
		ASL	
		TAY	
		STY	VoiceIndex
		DEX	
		LDA	TunePtrLo,X
		STA	TunePtr
		LDA	TunePtrHi,X
		STA	TunePtr+1
		LDA	NoteLen,X
		BEQ	NextPattern
		JMP	PtnNotDone
; ---------------------------------------------------------------------------

NextPattern:				
		LDY	ChannelIdx,X
		LDA	(TunePtr),Y
		CMP	#$FF
		BEQ	ResetChannel
		CMP	#$FE
		BNE	UpdatePattern
		JSR	MusicOff
		JMP	ChannelsDone
; ---------------------------------------------------------------------------

ResetChannel:				
		LDA	#0
		STA	NoteLen,X
		STA	ChannelIdx,X
		STA	PatternIdx,X
		JMP	NextPattern
; ---------------------------------------------------------------------------

UpdatePattern:				
		TAY	
		LDA	PatternLo,Y
		STA	PatternPtr
		LDA	PatternHi,Y
		STA	PatternPtr+1
		LDY	PatternIdx,X

NextNote:				
		LDA	(PatternPtr),Y
		BPL	SetNote
		AND	#$F
		TAX	
		LDA	FunctionLo,X
		STA	CallFunc+1
		LDA	FunctionHi,X
		STA	CallFunc+2
		LDX	ChannelNo

CallFunc:				
		JSR	$7000
		INY	
		JMP	NextNote
; ---------------------------------------------------------------------------

SetNote:				
		AND	#$1F
		TAX	
		LDA	NoteLenTab,X
		LDX	ChannelNo
		STA	NoteLen,X
		INY	
		TYA	
		STA	PatternIdx,X
		LDA	(PatternPtr),Y
		STA	Pitch,X
		CPX	#0
		BNE	loc_0_1FCF
		ASL	
		TAY	
		LDA	Note16Tab,Y
		STA	NoteVal
		LDA	Note16Tab+1,Y
		STA	NoteVal+2
		JMP	loc_0_1FDA
; ---------------------------------------------------------------------------

loc_0_1FCF:				
		TAY	
		LDA	Pitch8Tab,Y
		STA	Pitch8Hold,X
		LDY	VoiceIndex
		STA	NoteVal,Y

loc_0_1FDA:				
		LDA	#0
		STA	EnvOffset,X
		INC	PatternIdx,X
		LDY	PatternIdx,X
		LDA	(PatternPtr),Y
		CMP	#$FF
		BNE	PtnNotDone
		LDA	#0
		STA	PatternIdx,X
		INC	ChannelIdx,X

PtnNotDone:				
		LDA	Envelope,X
		TAX	
		LDA	EnvPtrLo,X
		STA	loc_0_2006+1
		LDA	EnvPtrHi,X
		STA	loc_0_2006+2
		LDX	ChannelNo
		LDY	EnvOffset,X

loc_0_2006:				
		LDA	$C000,Y
		CMP	#$FF
		BEQ	loc_0_2033
		BPL	loc_0_2020
		LDY	VoiceIndex
		PHA	
		LDA	#0
		STA	NoteVal,Y
		PLA	
		STA	NoteVal+1,Y
		INC	EnvOffset,X
		JMP	NoteDone
; ---------------------------------------------------------------------------

loc_0_2020:				
		LDY	VoiceIndex
		INC	EnvOffset,X
		ORA	Filter,X
		STA	NoteVal+1,Y
		CPX	#0
		BEQ	loc_0_2033
		LDA	Pitch8Hold,X
		STA	NoteVal,Y

loc_0_2033:				
		LDA	SquareFlag,X
		BEQ	TrillCheck
		LDA	SquareWave
		AND	#1
		BNE	loc_0_2044
		LDA	PitchMod,X
		JMP	loc_0_2046
; ---------------------------------------------------------------------------

loc_0_2044:				
		LDA	#0

loc_0_2046:				
		STA	AlterPitch+1
		SEC	
		LDA	Pitch,X

AlterPitch:				
		SBC	#0
		TAY	
		LDA	Pitch8Tab,Y
		LDY	VoiceIndex
		STA	NoteVal,Y

TrillCheck:				
		LDA	TrillEnable,X
		BEQ	NoteDone

GetTrill:				
		LDY	TrillPos,X
		INC	TrillPos,X
		LDA	TrillTab,Y
		CMP	#$1F
		BNE	AddTrill
		LDA	#0
		STA	TrillPos,X
		BEQ	GetTrill

AddTrill:				
		CLC	
		ADC	Pitch8Hold,X
		LDY	VoiceIndex
		STA	NoteVal,Y

NoteDone:				
		DEC	NoteLen,X
		DEX	
		BMI	ChannelsDone
		JMP	NextChannel
; ---------------------------------------------------------------------------

ChannelsDone:				
		LDA	MusicEnable
		BEQ	SetMusic
		RTS	
; ---------------------------------------------------------------------------

SetMusic:				
		LDX	#8

SetMusicLoop:				
		LDA	NoteVal,X
		STA	$D200,X
		DEX	
		BPL	SetMusicLoop
		RTS	
; ---------------------------------------------------------------------------

Function0:
		INY	
		LDA	(PatternPtr),Y
		STA	Envelope,X
		RTS	
; ---------------------------------------------------------------------------

Function1:
		INY	
		LDA	(PatternPtr),Y
		STA	PitchMod,X
		LDA	#1
		STA	SquareFlag,X
		RTS	
; ---------------------------------------------------------------------------

Function2:
		LDA	#0
		STA	SquareFlag,X
		RTS	
; ---------------------------------------------------------------------------

Function3:
		LDA	#$80
		BNE	loc_0_20B0

Function4:
		LDA	#$A0

loc_0_20B0:				
		STA	Filter,X
		RTS	
; ---------------------------------------------------------------------------

Function5:
		LDA	#1
		BNE	loc_0_20BA

Function6:
		LDA	#0

loc_0_20BA:				
		STA	TrillEnable,X
		RTS	
; ---------------------------------------------------------------------------

Function7:
		LDA	#$C0
		BNE	loc_0_20B0
; ---------------------------------------------------------------------------
FunctionLo:	.BYTE <Function0
		.BYTE <Function1
		.BYTE <Function2
		.BYTE <Function3
		.BYTE <Function4
		.BYTE <Function5
		.BYTE <Function6
		.BYTE <Function7
FunctionHi:	.BYTE >Function0
		.BYTE >Function1
		.BYTE >Function2
		.BYTE >Function3
		.BYTE >Function4
		.BYTE >Function5
		.BYTE >Function6
		.BYTE >Function7
NoteLenTab:	.BYTE 6, $C, $18	
		.BYTE $30, $60,	$48
		.BYTE $90, $3C,	$12
Pitch8Tab:	.BYTE $FF, $F1,	$E4, $D7 
		.BYTE $CB, $C0,	$B5, $AA
		.BYTE $A1, $98,	$8F, $87
		.BYTE $7F, $78,	$72, $6B
		.BYTE $65, $5F,	$5A, $55
		.BYTE $50, $4B,	$47, $43
		.BYTE $3F, $3C,	$38, $35
		.BYTE $32, $2F,	$2C, $2A
		.BYTE $27, $25,	$23, $21
		.BYTE $1F, $1D,	$1C, $1A
		.BYTE $17, $16,	$13, $F
		.BYTE 8, 0
Note16Tab:	.WORD $B38		
		.WORD $A8C
		.WORD $A00
		.WORD $96A
		.WORD $8E8
		.WORD $86A
		.WORD $7EF
		.WORD $780
		.WORD $708
		.WORD $6AE
		.WORD $646
		.WORD $5E6
		.WORD $595
		.WORD $541
		.WORD $4F6
		.WORD $4B0
		.WORD $46E
		.WORD $430
		.WORD $3F6
		.WORD $3BB
		.WORD $384
		.WORD $352
		.WORD $322
		.WORD $2F4
		.WORD $2C8
		.WORD $2A0
		.WORD $27A
		.WORD $255
		.WORD $FA
		.WORD $214
		.WORD $A
		.WORD 0
SquareWave:	.BYTE 0			
ChannelIdx:	.BYTE 0, 0, 0		
NoteLen:	.BYTE 0, 0, 0		
PatternIdx:	.BYTE 0, 0, 0		
Pitch:		.BYTE 0, 0, 0		
Envelope:	.BYTE 0, 1, 2		
Filter:	.BYTE $C0, $A0,	$A0	
PitchMod:	.BYTE 0, 0, 0		
		.BYTE	 1
TrillPos:	.BYTE 0, 0, 0		
TrillEnable:	.BYTE 0, 0, 0		
SawTooth:	.BYTE 0			
MusicControl:	.BYTE 0			
NoteVal:	.WORD 0, $A800,	$A800, $A800 
		.BYTE  $50
TrillTab:	.BYTE	 0
		.BYTE	 1
		.BYTE	 1
		.BYTE	 0
		.BYTE	 0
		.BYTE  $FF
		.BYTE  $FE
		.BYTE  $FF
		.BYTE  $1F
EnvPtrLo:	.BYTE <Env1, <Env2, <Env3, <Env4, <Env5
EnvPtrHi:	.BYTE >Env1, >Env2, >Env3, >Env4, >Env5
Env1:		.BYTE $E, $D, $C, $B
		.BYTE 8, 7, 5, $FF
Env2:		.BYTE $E, $4D, $B, $4A,	8, $48
		.BYTE 8, 7, 7, 7, 6, 6
		.BYTE 6, 5, 5, 5, 4, 4
		.BYTE 4, 4, 3, 3, 3, 2
		.BYTE 2, 2, 2, 2, 1, 1
		.BYTE 1, 1, 1, 1, 0, $FF
Env3:		.BYTE $8A, $C, 9, 9
		.BYTE 8, 7, 6, 5
		.BYTE 4, 0, $FF
Env4:		.BYTE 0, 1, 2, 6, 8, $A
		.BYTE $F, $E, $C, $A, 9, 9
		.BYTE 8, 8, 7, 7, 6, $FF
Env5:		.BYTE $8C, $A, $FF
TunePtrLo:	.BYTE <Tune1, <Tune2, <Tune3
TunePtrHi:	.BYTE >Tune1, >Tune2, >Tune3
PatternLo:	.BYTE <Pattern0
		.BYTE <Pattern1
		.BYTE <Pattern2
		.BYTE <Pattern3
		.BYTE <Pattern4
		.BYTE <Pattern5
		.BYTE <Pattern6
		.BYTE <Pattern7
		.BYTE <Pattern8
		.BYTE <Pattern9
		.BYTE <PatternA
		.BYTE <PatternB
		.BYTE <PatternC
		.BYTE <PatternD
		.BYTE <PatternE
		.BYTE <PatternF
		.BYTE <Pattern10
		.BYTE <Pattern11
		.BYTE <Pattern12
		.BYTE <Pattern13
		.BYTE <Pattern14
		.BYTE <Pattern15
		.BYTE <Pattern16
		.BYTE <Pattern17
		.BYTE <Pattern18
		.BYTE <Pattern19
		.BYTE <Pattern1A
PatternHi:	.BYTE >Pattern0
		.BYTE >Pattern1
		.BYTE >Pattern2
		.BYTE >Pattern3
		.BYTE >Pattern4
		.BYTE >Pattern5
		.BYTE >Pattern6
		.BYTE >Pattern7
		.BYTE >Pattern8
		.BYTE >Pattern9
		.BYTE >PatternA
		.BYTE >PatternB
		.BYTE >PatternC
		.BYTE >PatternD
		.BYTE >PatternE
		.BYTE >PatternF
		.BYTE >Pattern10
		.BYTE >Pattern11
		.BYTE >Pattern12
		.BYTE >Pattern13
		.BYTE >Pattern14
		.BYTE >Pattern15
		.BYTE >Pattern16
		.BYTE >Pattern17
		.BYTE >Pattern18
		.BYTE >Pattern19
		.BYTE >Pattern1A
Tune1:		.BYTE 7, 7, 7, 7, 6, 6,	6, 6
		.BYTE 7, 7, 7, 7, 6, 6,	6, 6
		.BYTE 2, 3, 4, 4, 2, 3,	4, 4
		.BYTE 2, 6, 7, 7, 8, 3,	4, 4
		.BYTE 3, 3, 4, 4, 3, 3,	4, 4
		.BYTE 3, 3, 4, 4, 3, 3,	4, 4
		.BYTE 3, 3, 4, 4, 3, 3,	4, 4
		.BYTE 3, 3, 4, 4, 3, 3,	4, 4
		.BYTE 3, 3, 4, 4, 2, 3,	4, 4
		.BYTE 2, 3, 4, 4, 2, 6,	7, 7
		.BYTE 8, 3, 4, 4, $E, $E, $E, $E
		.BYTE $E, $E, $E, $E, $F, $F, $F, $F
		.BYTE $E, $E, $E, $E, $F, $F, $F, $F
		.BYTE $15, $15,	$16, $16, $15, $15, $F,	$F
		.BYTE $E, $E, $F, $F, $E, $E, $F, $F
		.BYTE $E, $E, $E, $E, $F, $F, $F, $F
		.BYTE $FF
Tune2:		.BYTE 9, 9, 1, 1, $A, $A, $C, $D
		.BYTE $D, $A, $A, 1, 1,	0, 0, 0
		.BYTE 0, $11, $11, $12,	$12, $13, $13, $14
		.BYTE $14, $14,	$14, $17, $17, $18, $18, $17
		.BYTE $17, $19,	$19, $1A, $1A, $11, $11, $12
		.BYTE $12, $FF
Tune3:		.BYTE 9, 5, 5, 5, 5, 5,	5, 5
		.BYTE 5, 5, 5, 5, 5, $B, $B, $B
		.BYTE $B, $B, $B, $B, $B, $B, $B, $B
		.BYTE $B, $B, $B, $B, $B, $B, $B, 5
		.BYTE 5, 5, 5, 5, 5, 5,	5, 0
		.BYTE 0, $10, $10, $10,	$10, $10, $10, $10
		.BYTE $10, $10,	$10, $10, $10, $10, $10, $10
		.BYTE $10, $10,	$10, $10, $10, $10, $10, $10
		.BYTE $10, $10,	$10, $10, $10, $10, $10, $10
		.BYTE $10, $10,	$10, $10, $10, $10, $10, $10
		.BYTE $10, $10,	$10, $FF
Pattern0:	.BYTE  $86
		.BYTE  $82
		.BYTE	 4
		.BYTE  $2D
		.BYTE  $FF
Pattern1:	.BYTE  $86
		.BYTE  $80
		.BYTE	 0
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 3
		.BYTE  $17
		.BYTE  $82
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 2
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $17
		.BYTE  $82
		.BYTE	 4
		.BYTE  $2D
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 3
		.BYTE  $17
		.BYTE  $82
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $21
		.BYTE	 1
		.BYTE  $23
		.BYTE	 1
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 2
		.BYTE  $15
		.BYTE	 2
		.BYTE  $17
		.BYTE  $82
		.BYTE	 4
		.BYTE  $2D
		.BYTE  $FF
Pattern9:	.BYTE  $84
		.BYTE  $82
		.BYTE  $80
		.BYTE	 3
		.BYTE  $85
		.BYTE	 5
		.BYTE  $10
		.BYTE	 2
		.BYTE  $12
		.BYTE	 6
		.BYTE	$B
		.BYTE	 2
		.BYTE  $12
		.BYTE	 2
		.BYTE  $15
		.BYTE	 3
		.BYTE  $10
		.BYTE	 3
		.BYTE  $12
		.BYTE	 5
		.BYTE  $10
		.BYTE	 2
		.BYTE	$E
		.BYTE	 6
		.BYTE	$B
		.BYTE	 3
		.BYTE  $15
		.BYTE	 3
		.BYTE  $17
		.BYTE	 3
		.BYTE  $12
		.BYTE  $FF
PatternA:	.BYTE  $80
		.BYTE	 3
		.BYTE  $85
		.BYTE	 1
		.BYTE	 9
		.BYTE	 7
		.BYTE	$B
		.BYTE	 2
		.BYTE  $10
		.BYTE	 3
		.BYTE  $12
		.BYTE	 3
		.BYTE	 9
		.BYTE	 1
		.BYTE	 9
		.BYTE	 7
		.BYTE	$B
		.BYTE	 2
		.BYTE  $15
		.BYTE	 3
		.BYTE  $17
		.BYTE	 3
		.BYTE  $12
		.BYTE  $FF
PatternC:	.BYTE	 5
		.BYTE	$B
		.BYTE	 2
		.BYTE  $17
		.BYTE	 3
		.BYTE  $15
		.BYTE	 3
		.BYTE  $12
		.BYTE	 1
		.BYTE  $10
		.BYTE	 1
		.BYTE  $12
		.BYTE	 1
		.BYTE  $10
		.BYTE	 1
		.BYTE	$E
		.BYTE	 2
		.BYTE  $10
		.BYTE	 2
		.BYTE  $15
		.BYTE	 3
		.BYTE  $17
		.BYTE	 3
		.BYTE	$B
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 2
		.BYTE  $17
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 4
		.BYTE  $17
		.BYTE	 3
		.BYTE  $17
		.BYTE	 5
		.BYTE  $17
		.BYTE	 2
		.BYTE  $23
		.BYTE	 3
		.BYTE  $21
		.BYTE	 3
		.BYTE  $1E
		.BYTE	 5
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 3
		.BYTE  $1C
		.BYTE	 3
		.BYTE  $17
		.BYTE  $FF
PatternD:	.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 2
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 2
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 2
		.BYTE  $21
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 2
		.BYTE  $23
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1A
		.BYTE  $FF
Pattern11:	.BYTE  $86
		.BYTE  $80
		.BYTE	 0
		.BYTE  $84
		.BYTE  $81
		.BYTE	 5
		.BYTE	 0
		.BYTE  $17
		.BYTE	 0
		.BYTE  $19
		.BYTE	 1
		.BYTE  $19
		.BYTE	 1
		.BYTE  $19
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 1
		.BYTE  $19
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 0
		.BYTE  $19
		.BYTE	 1
		.BYTE  $19
		.BYTE	 1
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 0
		.BYTE  $19
		.BYTE	 2
		.BYTE  $14
		.BYTE  $82
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $FF
Pattern12:	.BYTE  $81
		.BYTE	 5
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $20
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $23
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $23
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 1
		.BYTE  $19
		.BYTE	 2
		.BYTE  $1B
		.BYTE  $82
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $FF
Pattern13:	.BYTE  $81
		.BYTE	 5
		.BYTE	 8
		.BYTE  $19
		.BYTE	 8
		.BYTE  $17
		.BYTE	 2
		.BYTE  $17
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 8
		.BYTE  $19
		.BYTE	 8
		.BYTE  $17
		.BYTE	 2
		.BYTE  $17
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $23
		.BYTE	 0
		.BYTE  $25
		.BYTE	 1
		.BYTE  $25
		.BYTE  $FF
Pattern14:	.BYTE	 1
		.BYTE  $14
		.BYTE	 0
		.BYTE  $12
		.BYTE	 1
		.BYTE  $14
		.BYTE	 0
		.BYTE  $12
		.BYTE	 2
		.BYTE  $14
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $20
		.BYTE  $FF
Pattern17:	.BYTE  $84
		.BYTE  $82
		.BYTE  $80
		.BYTE	 4
		.BYTE  $85
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $17
		.BYTE	 1
		.BYTE  $19
		.BYTE  $83
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $FF
Pattern18:	.BYTE  $84
		.BYTE	 0
		.BYTE  $16
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $16
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $16
		.BYTE	 0
		.BYTE  $14
		.BYTE	 0
		.BYTE  $16
		.BYTE	 0
		.BYTE  $14
		.BYTE	 0
		.BYTE  $12
		.BYTE	 1
		.BYTE	$F
		.BYTE  $83
		.BYTE	 2
		.BYTE  $2D
		.BYTE  $FF
Pattern19:	.BYTE  $84
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $19
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $19
		.BYTE  $FF
Pattern1A:	.BYTE  $84
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $23
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $1C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $20
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 0
		.BYTE  $1B
		.BYTE	 0
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 1
		.BYTE  $1E
		.BYTE	 1
		.BYTE  $1B
		.BYTE	 1
		.BYTE  $19
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $14
		.BYTE  $FF
Pattern5:	.BYTE  $86
		.BYTE  $84
		.BYTE  $80
		.BYTE	 2
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 2
		.BYTE  $17
		.BYTE	 1
		.BYTE  $17
		.BYTE  $82
		.BYTE	 1
		.BYTE  $2C
		.BYTE	 1
		.BYTE  $2C
		.BYTE  $81
		.BYTE	 5
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $1A
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 1
		.BYTE  $1C
		.BYTE	 2
		.BYTE  $1A
		.BYTE  $82
		.BYTE	 1
		.BYTE  $2C
		.BYTE	 1
		.BYTE  $2C
		.BYTE  $83
		.BYTE	 1
		.BYTE  $2B
		.BYTE	 1
		.BYTE  $20
		.BYTE  $FF
PatternB:	.BYTE  $86
		.BYTE  $84
		.BYTE  $80
		.BYTE	 2
		.BYTE  $81
		.BYTE	 7
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $23
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $26
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $15
		.BYTE	 1
		.BYTE  $17
		.BYTE	 1
		.BYTE  $23
		.BYTE  $87
		.BYTE	 1
		.BYTE  $2D
		.BYTE  $84
		.BYTE	 1
		.BYTE  $26
		.BYTE  $87
		.BYTE	 1
		.BYTE  $2D
		.BYTE  $FF
Pattern10:	.BYTE  $83
		.BYTE  $80
		.BYTE	 2
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $2C
		.BYTE  $84
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $25
		.BYTE	 0
		.BYTE  $19
		.BYTE  $82
		.BYTE	 0
		.BYTE  $2A
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $20
		.BYTE	 0
		.BYTE  $19
		.BYTE  $82
		.BYTE	 0
		.BYTE  $2A
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $25
		.BYTE  $83
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $2C
		.BYTE  $84
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $19
		.BYTE	 0
		.BYTE  $25
		.BYTE	 0
		.BYTE  $19
		.BYTE  $82
		.BYTE	 0
		.BYTE  $2A
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $25
		.BYTE  $82
		.BYTE	 0
		.BYTE  $2A
		.BYTE  $81
		.BYTE	$C
		.BYTE	 0
		.BYTE  $19
		.BYTE  $FF
Pattern2:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	 2
		.BYTE	 2
		.BYTE	 2
		.BYTE	 1
		.BYTE	 2
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 1
		.BYTE	 2
		.BYTE	 1
		.BYTE	$E
		.BYTE  $FF
Pattern3:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	 4
		.BYTE	 2
		.BYTE	 4
		.BYTE	 1
		.BYTE	 4
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 1
		.BYTE	 4
		.BYTE	 1
		.BYTE  $10
		.BYTE  $FF
Pattern4:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	 6
		.BYTE	 2
		.BYTE	 6
		.BYTE	 1
		.BYTE	 6
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 1
		.BYTE	 6
		.BYTE	 1
		.BYTE  $12
		.BYTE  $FF
Pattern6:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	 1
		.BYTE	 2
		.BYTE	 1
		.BYTE	 1
		.BYTE	 1
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 2
		.BYTE	$D
		.BYTE  $FF
Pattern7:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	$B
		.BYTE	 2
		.BYTE	$B
		.BYTE	 1
		.BYTE	$B
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 1
		.BYTE	$B
		.BYTE	 1
		.BYTE  $17
		.BYTE  $FF
Pattern8:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 1
		.BYTE	 9
		.BYTE	 2
		.BYTE	 9
		.BYTE	 1
		.BYTE	 9
		.BYTE  $83
		.BYTE	 2
		.BYTE  $1C
		.BYTE  $87
		.BYTE	 2
		.BYTE	 9
		.BYTE  $FF
PatternE:	.BYTE  $80
		.BYTE	 1
		.BYTE  $87
		.BYTE	 8
		.BYTE	 8
		.BYTE	 0
		.BYTE  $14
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1B
		.BYTE  $87
		.BYTE	 1
		.BYTE	 8
		.BYTE	 0
		.BYTE	 8
		.BYTE	 1
		.BYTE	$B
		.BYTE	 0
		.BYTE	$D
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1D
		.BYTE  $87
		.BYTE	 0
		.BYTE  $12
		.BYTE	 0
		.BYTE  $14
		.BYTE  $FF
PatternF:	.BYTE	 8
		.BYTE	 3
		.BYTE	 0
		.BYTE	$F
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1B
		.BYTE  $87
		.BYTE	 1
		.BYTE	 3
		.BYTE	 0
		.BYTE	 3
		.BYTE	 1
		.BYTE	 6
		.BYTE	 0
		.BYTE	 8
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1D
		.BYTE  $87
		.BYTE	 0
		.BYTE	$D
		.BYTE	 0
		.BYTE	$F
		.BYTE  $FF
Pattern15:	.BYTE	 8
		.BYTE	 1
		.BYTE	 0
		.BYTE	$D
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1B
		.BYTE  $87
		.BYTE	 1
		.BYTE	 1
		.BYTE	 0
		.BYTE	 1
		.BYTE	 1
		.BYTE	 4
		.BYTE	 0
		.BYTE	 6
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1D
		.BYTE  $87
		.BYTE	 0
		.BYTE	$A
		.BYTE	 0
		.BYTE	$D
		.BYTE  $FF
Pattern16:	.BYTE	 8
		.BYTE	$A
		.BYTE	 0
		.BYTE	$A
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1B
		.BYTE  $87
		.BYTE	 1
		.BYTE	$A
		.BYTE	 0
		.BYTE	$A
		.BYTE	 1
		.BYTE	 1
		.BYTE	 0
		.BYTE	 3
		.BYTE  $83
		.BYTE	 1
		.BYTE  $1D
		.BYTE  $87
		.BYTE	 0
		.BYTE  $14
		.BYTE	 0
		.BYTE  $16
		.BYTE  $FF
; ---------------------------------------------------------------------------

MusicOn:				
		LDA	#0
		LDX	#$E

loc_0_26C4:				
		STA	TunePtr,X
		DEX	
		BPL	loc_0_26C4
		LDA	#$40

loc_0_26CB:				
		STA	MusicControl
		RTS	
;
MusicOff:				
		LDA	#$C0
		BNE	loc_0_26CB

		run $2000